// Copyright  2016-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifdef DLL
// https://msdn.microsoft.com/en-us/library/ms682583.aspx

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH\n",
		               "DLL_PROCESS_ATTACH\n",
		               "DLL_THREAD_ATTACH\n",
		               "DLL_THREAD_DETACH\n"};

// https://msdn.microsoft.com/en-us/library/ms682596.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
#ifdef VERBOSE
	DWORD	dwConsole;

	// https://msdn.microsoft.com/en-us/library/ms687401.aspx
	// https://msdn.microsoft.com/en-us/library/ms683231.aspx
	// https://msdn.microsoft.com/en-us/library/ms647492.aspx

	WriteConsoleA(GetStdHandle(STD_ERROR_HANDLE), szReason[dwReason], lstrlenA(szReason[dwReason]), &dwConsole, NULL);
#else
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA(szReason[dwReason]);
#endif
	return FALSE;
}

__declspec(dllexport)
const	CHAR	SNAFU[] = "Situation normal, all\b\b\bbut \"/DEPENDENTLOADFLAG\" fucked up!\n";
#else
#ifdef LOADTIME
__declspec(dllimport)
extern	const	CHAR	SNAFU[];

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	WINAPI	mainCRTStartup(VOID)
{
#ifdef VERBOSE
	DWORD	dwConsole;

	// https://msdn.microsoft.com/en-us/library/ms687401.aspx
	// https://msdn.microsoft.com/en-us/library/ms683231.aspx
	// https://msdn.microsoft.com/en-us/library/ms647492.aspx

	WriteConsoleA(GetStdHandle(STD_ERROR_HANDLE), SNAFU, lstrlenA(SNAFU), &dwConsole, NULL);
#else
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA(SNAFU);
#endif
	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(0);
}
#else
// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	WINAPI	mainCRTStartup(VOID)
{
	DWORD	dwError = ERROR_SUCCESS;

	// https://msdn.microsoft.com/en-us/library/ms684175.aspx

	HMODULE	hModule = LoadLibraryA("SNAFU.DLL");

	if (hModule == NULL)

		// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError = GetLastError();
	else
		// https://msdn.microsoft.com/en-us/library/ms683152.aspx

		if (!FreeLibrary(hModule))
			dwError = GetLastError();

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
#endif // LOADTIME
#endif // DLL

#ifdef LCU
#ifndef _WIN64
// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_32
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD	DeCommitFreeBlockThreshold;
	DWORD	DeCommitTotalFreeThreshold;
	DWORD	LockPrefixTable;
	DWORD	MaximumAllocationSize;
	DWORD	VirtualMemoryThreshold;
	DWORD	ProcessHeapFlags;
	DWORD	ProcessAffinityMask;
	WORD	CSDVersion;
	WORD	DependentLoadFlags;
	DWORD	EditList;
	DWORD	SecurityCookie;
	DWORD	SEHandlerTable;
	DWORD	SEHandlerCount;
#if LCU > 1				// Threshold 1
	DWORD	GuardCFCheckFunctionPointer;
	DWORD	GuardCFDispatchFunctionPointer;
	DWORD	GuardCFFunctionTable;
	DWORD	GuardCFFunctionCount;
	DWORD	GuardFlags;
#if LCU > 2				// Threshold 2
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
#if LCU > 3				// Redstone 1
	DWORD	GuardAddressTakenIatEntryTable;
	DWORD	GuardAddressTakenIatEntryCount;
	DWORD	GuardLongJumpTargetTable;
	DWORD	GuardLongJumpTargetCount;
	DWORD	DynamicValueRelocTable;
	DWORD	CHPEMetadataPointer;
#if LCU > 4				// Redstone 2
	DWORD	GuardRFFailureRoutine;
	DWORD	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
#if LCU > 5				// Redstone 3
	DWORD	Reserved3;
	DWORD	EnclaveConfigurationPointer;
#if LCU > 6				// Redstone 4
	DWORD	VolatileMetadataPointer;
#if LCU > 7				// Redstone 5
	DWORD	GuardEHContinuationTable;
	DWORD	GuardEHContinuationCount;
#if LCU > 8				// Vibranium 3 (21H1)
	DWORD	GuardXFGCheckFunctionPointer;
	DWORD	GuardXFGDispatchFunctionPointer;
	DWORD	GuardXFGTableDispatchFunctionPointer;
#if LCU > 9				// Vibranium 4 (21H2)
	DWORD	CastGuardOsDeterminedFailureMode;
#if LCU > 10				// Vibranium 5 (22H2)
	DWORD	GuardMemcpyFunctionPointer;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
} _load_config_used = {sizeof(_load_config_used), 'OUCH', _MSC_VER / 100, _MSC_VER % 100};
#else
// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_64
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD64	DeCommitFreeBlockThreshold;
	DWORD64	DeCommitTotalFreeThreshold;
	DWORD64	LockPrefixTable;
	DWORD64	MaximumAllocationSize;
	DWORD64	VirtualMemoryThreshold;
	DWORD64	ProcessAffinityMask;
	DWORD	ProcessHeapFlags;
	WORD	CSDVersion;
	WORD	DependentLoadFlags;
	DWORD64	EditList;
	DWORD64	SecurityCookie;
	DWORD64	SEHandlerTable;
	DWORD64	SEHandlerCount;
#if LCU > 1				// Threshold 1
	DWORD64	GuardCFCheckFunctionPointer;
	DWORD64	GuardCFDispatchFunctionPointer;
	DWORD64	GuardCFFunctionTable;
	DWORD64	GuardCFFunctionCount;
	DWORD	GuardFlags;
#if LCU > 2				// Threshold 2
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
#if LCU > 3				// Redstone 1
	DWORD64	GuardAddressTakenIatEntryTable;
	DWORD64	GuardAddressTakenIatEntryCount;
	DWORD64	GuardLongJumpTargetTable;
	DWORD64	GuardLongJumpTargetCount;
	DWORD64	DynamicValueRelocTable;
	DWORD64	CHPEMetadataPointer;
#if LCU > 4				// Redstone 2
	DWORD64	GuardRFFailureRoutine;
	DWORD64	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD64	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
#if LCU > 5				// Redstone 3
	DWORD	Reserved3;
	DWORD64	EnclaveConfigurationPointer;
#if LCU > 6				// Redstone 4
	DWORD64	VolatileMetadataPointer;
#if LCU > 7				// Redstone 5
	DWORD64	GuardEHContinuationTable;
	DWORD64	GuardEHContinuationCount;
#if LCU > 8				// Vibranium 3 (21H1)
	DWORD64	GuardXFGCheckFunctionPointer;
	DWORD64	GuardXFGDispatchFunctionPointer;
	DWORD64	GuardXFGTableDispatchFunctionPointer;
#if LCU > 9				// Vibranium 4 (21H2)
	DWORD64	CastGuardOsDeterminedFailureMode;
#if LCU > 10				// Vibranium 5 (22H2)
	DWORD64	GuardMemcpyFunctionPointer;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
} _load_config_used = {sizeof(_load_config_used), 'OUCH', _MSC_VER / 100, _MSC_VER % 100};
#endif // _WIN64
#endif // LCU
